#!/client/bin/perl -Tw

# 2html.pl
# subroutines to read in a template and write out an html file
#
# most important routine:
# o outp
# o some other to help outp

#######################################################################
# sub routines
#######################################################################

$mailprog = "/client/bin/smail -i -t";

# save_outp: Gib eine HTML Antwort aus, in der einige Variablen durch Werte
#       ersetzt wurden.
# WICHTIG: Die Reihenfolge der Ersetzung ist nicht definiert, wg. array
# IN:
# o file descriptor to write to
# o filename relativ zu template_dir
# o hash of variable, value
# OUT: "" == erfolgreich
#      anything else == nicht erfolgreich
#  output(template, array of variables)
#
# Beispielaufruf:
# save_outp("/some/file/path.html","cgi-res-sample",%val);
# - conditional execution
#   __if __variable__ [ optional: OP __value__ mit "op" aus =, !=]
#   __endif
#   funktioniert auch verschachtelt
#
# TODO:
# - Was passiert, wenn in der Eingabe __VAR__'s vorkommen, die
#   im Array nicht definiert sind ?
#   Antwort: __var__ wird aus dem output geloescht, sonst nichts
# - Was passiert, wenn im Array Werte vorkommen, die in der Eingabe
#   nicht definiert sind ?
#   Antwort: Sie werden nirgends eingesetzt.
#   TODO: Zaehler, der evt. darauf hinweist, wie oft jede variable
#   angewendet werden konnte.
# - conditional execution mit vollen perl ops
# - TODO: Erkennen, wenn eine variable eine Referenz auf einen Hash ist
#   und dann schleifen zulassen.
# - TODO: __include funktion ?
#
sub save_outp
{
    my($outf,$templ,%val) = @_;
    my($tmp);
    my($key);
    my($filehandle);
    my($var);
    my($iflevel) = 0;
    my($line);

    open(INP,"<$main::template_dir/$templ") or return "save_outp: can not read template $main::template_dir/$templ";
    if ($outf eq '-') {
	print "Content-type: text/html\n\n";
	$filehandle = *STDOUT;
    }
    elsif ( $outf eq '' ) {
	$filehandle = *STDOUT;
    }
    elsif ( $outf =~ /\@/)  {	# contains e-mail address, send template as mail
	open(OUT,"|$mailprog") or return "save_outp: can not mail to $outf";
	$filehandle = *OUT;
	if ( $val{'recipient'} eq '' ) {
	    $val{'recipient'} = $outf;
	}
    }
    else {
	open(OUT,">$outf") or return "save_outp: can not write $outf";
	$filehandle = *OUT;
    }

    # search input for variables
    # look up action for that variable
    # produce output, if required
    while( defined($line=<INP>) ) {

	# print STDERR "if: $iflevel line: $line\n";
	next if ( $line =~ /^#/ );	# allow comment lines

	if ( $line =~ /^__if\s/ ) {	# condition
	    ($var, $j, $op, $val ) =
		( $line =~ /^__if\s+__(\S+)__(\s+(\S+)\s+(.+))*$/ );

	    # print STDERR "if: var: $var op: $op val: $val\n";

	    if ( $iflevel > 0 || ( $val{$var} eq "" && $op eq "") ) {
		$iflevel++;
		next;
	    }

	    if ( $iflevel > 0 || ( $op eq "=" && $val{$var} ne $val) ) {
		$iflevel++;
		next;
	    }

	    if ( $iflevel > 0 || ( $op eq "!=" && $val{$var} eq $val) ) {
		$iflevel++;
		next;
	    }

	    next;
	}

	if ( $line =~ /^__ifnot\s/ ) {	# condition
	    ($var, $j, $op, $val ) =
		( $line =~ /^__ifnot\s+__(\S+)__(\s+(\S+)\s+(.+))*$/ );

	    # print STDERR "ifnot: var: $var op: $op val: $val\n";

	    if ( $iflevel > 0 || ( $val{$var} ne "" && $op eq "") ) {
		$iflevel++;
		next;
	    }

	    if ( $iflevel > 0 || ( $op eq "=" && $val{$var} eq $val) ) {
		$iflevel++;
		next;
	    }

	    if ( $iflevel > 0 || ( $op eq "!=" && $val{$var} ne $val) ) {
		$iflevel++;
		next;
	    }

	    next;
	}

 	if ( $line =~ /^__endif/) {	# end condition
	    if ($iflevel > 0) {
		$iflevel--;
	    }
	    next;
	}

	next if ($iflevel > 0);

	while(1) {
	    # search and replace issue
	    ($var) = ( $line =~ /__([a-zA-Z0-9_]+)__/ );

	    if ( !defined($var) ) {	# alles gefunden und ersetzt,
	   				# schreib es raus.
        	print $filehandle $line;
		last;
	    }

	    if ($val{$var} eq '' ) {
		# TODO undefined variable, this should not happen
	    }
	    $line =~ s/__($var)__/$val{$var}/g;
	}

    }

    close(INP);
    if ($outf ne '-') {			# dont close if stdout
	close($filehandle);
    }

    return "";
}

# quick hack
sub outp
{
    my($templ,%val) = @_;
    return &save_outp('-',$templ,%val);
}

# Print the full cgi result for the user to debug...
sub oldresponse {
    my($key);
    my(%cgi_data)= %main::cgi_data;
    my(%cgi_cfn)= %main::cgi_cfn;
    my(%cgi_ct)= %main::cgi_ct;
    my(%cgi_sfn)= %main::cgi_sfn;
  
    print "Content-Type: text/plain\n\n";

    print "programm: $0\n";
    print "real-uid: $<\n";
    print "effective-uid: $>\n";
    print "real-gids: $(\n";
    print "effective-gids: $)\n";
    print "\n";

    foreach $key (0..$#ARGV) {
        print "argv[$key]: $ARGV[$key]\n";
    }
    print "\n";
  
    foreach $key (keys(%cgi_data)) {
	print "cgi-varname: $key\n";
	print "cgi-varvalue: $cgi_data{$key}\n";
	print "cgi-cfnval: $cgi_cfn{$key}\n";
	print "cgi-ctval: $cgi_ct{$key}\n";
	print "cgi-sfnval: $cgi_sfn{$key}\n";
	print "\n";
    }

    foreach $key (keys(%ENV)) {
	print "ENV-variable: $key\n";
	print "ENV-value: $ENV{$key}\n";
	print "\n";
    }
}

1;

